diff -ruN ../nakedmudv2.2/src/scripts/pyplugs.c src/scripts/pyplugs.c
--- ../nakedmudv2.2/src/scripts/pyplugs.c	Wed Dec 31 17:00:00 1969
+++ src/scripts/pyplugs.c	Fri May 27 01:30:57 2005
@@ -0,0 +1,239 @@
+//*****************************************************************************
+//
+// pyplugs.c
+//
+// Pyplugs are just various things that occur at the intersection between 
+// Python and C, in NakedMud. They include the loading of python modules,
+// a few commands for interacting with python modules, and miscellaneory (sp?)
+// python stuff that doesn't neccessarily fall under "scripting".
+//
+//*****************************************************************************
+
+#include <Python.h>
+#include <structmember.h>
+#include <compile.h>
+#include <dirent.h> 
+#include <node.h>
+
+#include "../mud.h"
+#include "../utils.h"
+#include "../character.h"
+#include "pyplugs.h"
+
+
+
+//*****************************************************************************
+// local functions, structures, and defines
+//*****************************************************************************
+
+// the directory where we keep python modules that we have extended ourself with
+#define PYMOD_LIB       "../lib/pymodules"
+
+
+//
+// Similar to Py_CompileString (in the Python API), but a file is compiled
+// instead. fname is the file that will be compiled. The code object will be
+// stored in a file named fname + c (e.g. foo.py becomes foo.pyc)
+PyObject *Py_CompileFile(char *fname) {
+  FILE *fl = fopen(fname, "r");
+  if(fl == NULL) return NULL;
+  char cfname[strlen(fname) + 2];
+  sprintf(cfname, "%sc", fname);
+
+  struct _node *node = PyParser_SimpleParseFile(fl, fname, Py_file_input);
+  if(node == NULL) return NULL;
+  PyCodeObject *code = PyNode_Compile(node, cfname);
+  PyNode_Free(node);
+  fclose(fl);
+  return (PyObject *)code;
+}
+
+
+//
+// reads in one python module, and adds it to the game. Fname is the name of
+// the file we are reading the module from, and mname is the name of the module
+// we will be storing it as. This function will reload the module if it has
+// already been loaded
+bool PyModule_Reload(char *fname, char *mname) {
+  PyObject *code = Py_CompileFile(fname);
+  if(code == NULL) {
+    char *tb = getPythonTraceback();
+    log_string("Error in module file: %s\r\n"
+	       "\r\nTraceback is:\r\n%s\r\n", fname, tb);
+    free(tb);
+    return FALSE;
+  }
+  // no errors occured... load the module into our package
+  else {
+    PyObject *module = PyImport_ExecCodeModule(mname, code);
+    if(module == NULL) {
+      char *tb = getPythonTraceback();
+      log_string("Error in module file: %s\r\n"
+		 "\r\nTraceback is:\r\n%s\r\n", fname, tb);
+      free(tb);
+      return FALSE;
+    }
+    else
+      Py_DECREF(module);
+    Py_DECREF(code);
+    return TRUE;
+  }
+}
+
+//
+// takes the name of a python module, and loads that module into the game
+COMMAND(cmd_pyload) {
+  if(!*arg)
+    send_to_char(ch, "Which module did you want to load?\r\n");
+  else {
+    char fname[strlen(arg) + 6 + 4];
+    sprintf(fname, "%s/%s.py", PYMOD_LIB, arg);
+    // make sure the file exists
+    if(!file_exists(fname))
+      send_to_char(ch, "That module does not exist!\r\n");
+    else if(PyModule_Reload(fname, arg))
+      send_to_char(ch, "Module successfully loaded.\r\n");
+  }
+}
+
+//
+// NakedMud allows you to extend the codebase in Python. These extensions must
+// take the form of Python modules, and must be stored in the PYMOD_LIB
+// directory. These modules might add new commands to the mud, or provide new
+// functions that scripts or other extension modules can use. The game datatypes
+// (i.e. chars, rooms, objects, etc...) cannot be extended by Python, but just
+// about any other feature of the mud can be.
+void init_py_modules() {
+  // build a list of all the files in this directory
+  static char fname[SMALL_BUFFER];
+  static char mname[SMALL_BUFFER];
+  DIR *dir = opendir(PYMOD_LIB);
+  struct dirent *entry;
+
+  // add our PYMOD_LIB directory to the sys path, 
+  // so the modules can access each other
+  PyObject *sys  = PyImport_ImportModule("sys");
+  PyObject *path = (sys ? PyDict_GetItemString(PyModule_GetDict(sys), "path") :
+		    NULL);
+  if(path != NULL)
+    PyList_Append(path, Py_BuildValue("s", PYMOD_LIB));
+  else
+    log_string("ERROR: Unable to add %s to python sys.path", PYMOD_LIB);
+
+  // go through each of our python modules, and add them to the pymod package
+  for(entry = readdir(dir); entry; entry = readdir(dir)) {
+    // if it doesn't end in .py, ignore it
+    int nlen = strlen(entry->d_name);
+    if(nlen < 4 || strcasecmp(".py", entry->d_name + nlen-3) != 0)
+      continue;
+    sprintf(fname, "%s/%s", PYMOD_LIB, entry->d_name);
+    sprintf(mname, "%s",    entry->d_name);
+    mname[strlen(mname)-3] = '\0';
+
+    // Load the module if it hasn't been loaded yet
+    PyObject *mod = PyImport_ImportModule(mname);
+    if(mod != NULL)
+      log_string("loading python module, %s", mname);
+    // oops... something went wrong. Let's get the traceback
+    else {
+      char *tb = getPythonTraceback();
+      log_string("Error loading module, %s:\r\n%s\r\n",
+		 mname, tb);
+      free(tb);
+    }
+  }
+  closedir(dir);
+}
+
+
+
+//*****************************************************************************
+// implementation of pyplugs.h
+//*****************************************************************************
+void init_pyplugs(void) {
+  init_py_modules();
+  add_cmd("pyload", NULL, cmd_pyload, 0, POS_UNCONCIOUS, POS_FLYING,
+	  "admin", FALSE, FALSE);
+}
+
+
+
+//
+// Python makes it overly complicated (IMO) to get traceback information when
+// running in C. I spent some time hunting around, and came across a lovely
+// site that provided me with this function for getting a traceback of an error.
+// The site that provided this piece of code to me is located here:
+//   http://stompstompstomp.com/weblog/technical/2004-03-29
+char* getPythonTraceback(void) {
+    // Python equivilant:
+    // import traceback, sys
+    // return "".join(traceback.format_exception(sys.exc_type, 
+    //    sys.exc_value, sys.exc_traceback))
+
+    PyObject *type, *value, *traceback;
+    PyObject *tracebackModule;
+    char *chrRetval;
+
+    PyErr_Fetch(&type, &value, &traceback);
+
+    tracebackModule = PyImport_ImportModule("traceback");
+    if (tracebackModule != NULL) {
+        PyObject *tbList, *emptyString, *strRetval;
+
+        tbList = PyObject_CallMethod(
+            tracebackModule, 
+            "format_exception", 
+            "OOO",
+            type,
+            value == NULL ? Py_None : value,
+            traceback == NULL ? Py_None : traceback);
+
+        emptyString = PyString_FromString("");
+        strRetval = PyObject_CallMethod(emptyString, "join", "O", tbList);
+
+        chrRetval = strdup((strRetval ? PyString_AsString(strRetval) :
+			    "unknown error"));
+
+        Py_XDECREF(tbList);
+        Py_XDECREF(emptyString);
+        Py_XDECREF(strRetval);
+        Py_XDECREF(tracebackModule);
+    }
+    else
+      chrRetval = strdup("Unable to import traceback module.");
+
+    Py_XDECREF(type);
+    Py_XDECREF(value);
+    Py_XDECREF(traceback);
+
+    return chrRetval;
+}
+
+
+void makePyType(PyTypeObject *type, LIST *getsetters, LIST *methods) {
+  // build up the array of getsetters for this object
+  if(getsetters != NULL) {
+    PyGetSetDef *getsets = calloc(listSize(getsetters)+1,sizeof(PyGetSetDef));
+    LIST_ITERATOR  *gs_i = newListIterator(getsetters);
+    PyGetSetDef      *gs = NULL;
+    int i                = 0;
+    ITERATE_LIST(gs, gs_i) {
+      getsets[i] = *gs;
+      i++;
+    } deleteListIterator(gs_i);
+    type->tp_getset = getsets;
+  }
+  
+  // build up the array of methods for this object
+  if(methods != NULL) {
+    PyMethodDef *meth  = calloc(listSize(methods)+1, sizeof(PyMethodDef));
+    LIST_ITERATOR *m_i = newListIterator(methods);
+    PyMethodDef     *m = NULL;
+    int i              = 0;
+    ITERATE_LIST(m, m_i) {
+      meth[i] = *m;
+      i++;
+    } deleteListIterator(m_i);
+    type->tp_methods = meth;
+  }
+}
diff -ruN ../nakedmudv2.2/src/scripts/pyplugs.d src/scripts/pyplugs.d
--- ../nakedmudv2.2/src/scripts/pyplugs.d	Wed Dec 31 17:00:00 1969
+++ src/scripts/pyplugs.d	Fri May 27 01:33:33 2005
@@ -0,0 +1,3 @@
+scripts/pyplugs.d scripts/pyplugs.o: scripts/pyplugs.c mud.h wrapsock.h property_table.h list.h \
+  map.h hashtable.h set.h buffer.h bitvector.h utils.h character.h \
+  scripts/pyplugs.h
diff -ruN ../nakedmudv2.2/src/scripts/pyplugs.h src/scripts/pyplugs.h
--- ../nakedmudv2.2/src/scripts/pyplugs.h	Wed Dec 31 17:00:00 1969
+++ src/scripts/pyplugs.h	Fri May 27 01:30:57 2005
@@ -0,0 +1,28 @@
+#ifndef PYPLUGS_H
+#define PYPLUGS_H
+//*****************************************************************************
+//
+// pyplugs.h
+//
+// Pyplugs are just various things that occur at the intersection between 
+// Python and C, in NakedMud. They include the loading of python modules,
+// a few commands for interacting with python modules, and miscellaneory (sp?)
+// python stuff that doesn't neccessarily fall under "scripting".
+//
+//*****************************************************************************
+
+// 
+// Returns a string representation of the last error that Python threw. Must
+// be freed afterwards.
+char *getPythonTraceback(void);
+
+//
+// initialize all of our plugs with python
+void init_pyplugs();
+
+//
+// Takes in a PyType, and adds lists of get/setters and methods to it. The
+// lists can each be NULL if there are no getsetters or methods, respectively
+void makePyType(PyTypeObject *type, LIST *getsetters, LIST *methods);
+
+#endif // PYPLUGS_H
diff -ruN ../nakedmudv2.2/src/scripts/pyroom.c src/scripts/pyroom.c
--- ../nakedmudv2.2/src/scripts/pyroom.c	Thu May 12 17:08:51 2005
+++ src/scripts/pyroom.c	Fri May 27 01:30:57 2005
@@ -2,8 +2,9 @@
 //
 // pyroom.c
 //
-// A python extention to allow python scripts to treat MUD characters as an
-// object within the script.
+// Contains the implementation of a module that contains all of the methods
+// for dealing with rooms. Also contains a Python Class implementation of
+// NakedMud rooms.
 //
 //*****************************************************************************
 
@@ -15,15 +16,27 @@
 #include "../room.h"
 #include "../exit.h"
 #include "../character.h"
-#include "../races.h"
 #include "../handler.h"
 #include "../utils.h"
 
-#include "script.h"
+#include "pyplugs.h"
 #include "script_set.h"
-#include "pyroom.h"
+#include "script.h"
 #include "pychar.h"
 #include "pyobj.h"
+#include "pyroom.h"
+
+
+
+//*****************************************************************************
+// local structures and defines
+//*****************************************************************************
+
+// a list of the get/setters on the Room class
+LIST *pyroom_getsetters = NULL;
+
+// a list of the methods on the Room class
+LIST *pyroom_methods = NULL;
 
 typedef struct {
   PyObject_HEAD
@@ -33,25 +46,21 @@
 
 
 //*****************************************************************************
-// allocation, deallocation, and initialiation
+// allocation, deallocation, initialization, and comparison
 //*****************************************************************************
-static void
-PyRoom_dealloc(PyRoom *self) {
+void PyRoom_dealloc(PyRoom *self) {
   self->ob_type->tp_free((PyObject*)self);
 }
 
-static PyObject *
-PyRoom_new(PyTypeObject *type, PyObject *args, PyObject *kwds) {
+PyObject *PyRoom_new(PyTypeObject *type, PyObject *args, PyObject *kwds) {
     PyRoom *self;
-
-    self = (PyRoom  *)type->tp_alloc(type, 0);
+    self = (PyRoom *)type->tp_alloc(type, 0);
     self->vnum = NOWHERE;
     return (PyObject *)self;
 }
 
-static int
-PyRoom_init(PyRoom *self, PyObject *args, PyObject *kwds) {
-  static char *kwlist[] = {"vnum", NULL};
+int PyRoom_init(PyRoom *self, PyObject *args, PyObject *kwds) {
+  char *kwlist[] = {"vnum", NULL};
   int vnum = NOWHERE;
 
   // get the vnum
@@ -64,7 +73,7 @@
   // make sure a room with the vnum exists
   if(!worldGetRoom(gameworld, vnum)) {
     PyErr_Format(PyExc_TypeError, 
-		 "Rom with vnum, %d, does not exist", vnum);
+		 "Room with vnum, %d, does not exist", vnum);
     return -1;
   }
 
@@ -72,16 +81,69 @@
   return 0;
 }
 
+int PyRoom_compare(PyRoom *room1, PyRoom *room2) {
+  if(room1->vnum == room2->vnum)
+    return 0;
+  else if(room1->vnum < room2->vnum)
+    return -1;
+  else
+    return 1;
+}
+
 
 
 //*****************************************************************************
-// methods and stuff for building the class
+// getters and setters for the Room class
+//*****************************************************************************
+PyObject *PyRoom_getvnum(PyRoom *self, void *closure) {
+  ROOM_DATA *room = PyRoom_AsRoom((PyObject *)self);
+  if(room != NULL) return Py_BuildValue("i", roomGetVnum(room));
+  else             return NULL;
+}
+
+PyObject *PyRoom_getchars(PyRoom *self, PyObject *args) {
+  ROOM_DATA *room = PyRoom_AsRoom((PyObject *)self);
+  if(room == NULL)
+    return NULL;
+  else {
+    LIST_ITERATOR *char_i = newListIterator(roomGetCharacters(room));
+    PyObject *list = PyList_New(0);
+    CHAR_DATA *ch;
+
+    // for each char in the room list, add him to a Python list
+    ITERATE_LIST(ch, char_i)
+      PyList_Append(list, newPyChar(ch));
+    deleteListIterator(char_i);
+    return Py_BuildValue("O", list);
+  }
+}
+
+PyObject *PyRoom_getobjs(PyRoom *self, PyObject *args) {
+  ROOM_DATA *room = PyRoom_AsRoom((PyObject *)self);
+  if(room == NULL)
+    return NULL;
+  else {
+    LIST_ITERATOR *obj_i = newListIterator(roomGetContents(room));
+    PyObject *list = PyList_New(0);
+    OBJ_DATA *obj;
+
+    // for each obj in the room list, add him to a Python list
+    ITERATE_LIST(obj, obj_i)
+      PyList_Append(list, newPyObj(obj));
+    deleteListIterator(obj_i);
+    return Py_BuildValue("O", list);
+  }
+}
+
+
+
+//*****************************************************************************
+// methods for the room class
 //*****************************************************************************
 
 //
 // Send a newline-tagged message to everyone in the room
-static PyObject *
-PyRoom_send(PyRoom *self, PyObject *value) {
+PyObject *PyRoom_send(PyRoom *self, PyObject *value) {
   char *mssg = NULL;
   if (!PyArg_ParseTuple(value, "s", &mssg)) {
     PyErr_Format(PyExc_TypeError, 
@@ -89,7 +151,7 @@
     return NULL;
   }
 
-  ROOM_DATA *room = worldGetRoom(gameworld, self->vnum);
+  ROOM_DATA *room = PyRoom_AsRoom((PyObject *)self);
   if(room) {
     send_to_list(roomGetCharacters(room), "%s\r\n", mssg);
     return Py_BuildValue("i", 1);
@@ -105,8 +167,7 @@
 
 //
 // close a door in the specified direction
-static PyObject *
-PyRoom_close(PyRoom *self, PyObject *value) {
+PyObject *PyRoom_close(PyRoom *self, PyObject *value) {
   ROOM_DATA *room = NULL;
   EXIT_DATA *exit = NULL;
   char *dirname = NULL;
@@ -118,7 +179,7 @@
     return NULL;
   }
 
-  room = worldGetRoom(gameworld, self->vnum);
+  room = PyRoom_AsRoom((PyObject *)self);
   if(room == NULL) {
     PyErr_Format(PyExc_TypeError, 
 		 "Tried to close door in non-existant room, %d.", 
@@ -157,8 +218,7 @@
 
 //
 // lock a door in the specified direction
-static PyObject *
-PyRoom_lock(PyRoom *self, PyObject *value) {
+PyObject *PyRoom_lock(PyRoom *self, PyObject *value) {
   ROOM_DATA *room = NULL;
   EXIT_DATA *exit = NULL;
   char *dirname = NULL;
@@ -170,7 +230,7 @@
     return NULL;
   }
 
-  room = worldGetRoom(gameworld, self->vnum);
+  room = PyRoom_AsRoom((PyObject *)self);
   if(room == NULL) {
     PyErr_Format(PyExc_TypeError, 
 		 "Tried to lock door in non-existant room, %d.", 
@@ -216,8 +276,7 @@
 
 //
 // lock a door in the specified direction
-static PyObject *
-PyRoom_unlock(PyRoom *self, PyObject *value) {
+PyObject *PyRoom_unlock(PyRoom *self, PyObject *value) {
   ROOM_DATA *room = NULL;
   EXIT_DATA *exit = NULL;
   char *dirname = NULL;
@@ -229,7 +288,7 @@
     return NULL;
   }
 
-  room = worldGetRoom(gameworld, self->vnum);
+  room = PyRoom_AsRoom((PyObject *)self);
   if(room == NULL) {
     PyErr_Format(PyExc_TypeError, 
 		 "Tried to unlock door in non-existant room, %d.", 
@@ -274,8 +333,7 @@
 
 //
 // close a door in the specified direction
-static PyObject *
-PyRoom_open(PyRoom *self, PyObject *value) {
+PyObject *PyRoom_open(PyRoom *self, PyObject *value) {
   ROOM_DATA *room = NULL;
   EXIT_DATA *exit = NULL;
   char *dirname = NULL;
@@ -287,7 +345,7 @@
     return NULL;
   }
 
-  room = worldGetRoom(gameworld, self->vnum);
+  room = PyRoom_AsRoom((PyObject *)self);
   if(room == NULL) {
     PyErr_Format(PyExc_TypeError, 
 		 "Tried to open door in non-existant room, %d.", 
@@ -318,8 +376,7 @@
 }
 
 
-static PyObject *
-PyRoom_attach(PyRoom *self, PyObject *args) {  
+PyObject *PyRoom_attach(PyRoom *self, PyObject *args) {  
   long vnum = NOTHING;
 
   // make sure we're getting passed the right type of data
@@ -330,7 +387,7 @@
   }
 
   // pull out the character and do the attaching
-  ROOM_DATA     *room = worldGetRoom(gameworld, self->vnum);
+  ROOM_DATA     *room = PyRoom_AsRoom((PyObject *)self);
   SCRIPT_DATA *script = worldGetScript(gameworld, vnum);
   if(room != NULL && script != NULL) {
     scriptSetAdd(roomGetScripts(room), vnum);
@@ -345,8 +402,7 @@
 }
 
 
-static PyObject *
-PyRoom_detach(PyRoom *self, PyObject *args) {  
+PyObject *PyRoom_detach(PyRoom *self, PyObject *args) {  
   long vnum = NOTHING;
 
   // make sure we're getting passed the right type of data
@@ -357,7 +413,7 @@
   }
 
   // pull out the character and do the attaching
-  ROOM_DATA     *room = worldGetRoom(gameworld, self->vnum);
+  ROOM_DATA     *room = PyRoom_AsRoom((PyObject *)self);
   SCRIPT_DATA *script = worldGetScript(gameworld, (int)vnum);
   if(room != NULL && script != NULL) {
     scriptSetRemove(roomGetScripts(room), vnum);
@@ -372,104 +428,11 @@
 }
 
 
-static PyMethodDef PyRoom_methods[] = {
-  {"attach", (PyCFunction)PyRoom_attach, METH_VARARGS,
-   "attach a new script to the room." },
-  {"detach", (PyCFunction)PyRoom_detach, METH_VARARGS,
-   "detach a script from the room." },
-  {"close", (PyCFunction)PyRoom_close, METH_VARARGS,
-   "close a door in the specified direction." },
-  {"open", (PyCFunction)PyRoom_open, METH_VARARGS,
-   "open a door in the specified direction. Unlocks it if neccessary." },
-  {"lock", (PyCFunction)PyRoom_lock, METH_VARARGS,
-   "lock a door in the specified direction, closing it if it is open." },
-  {"unlock", (PyCFunction)PyRoom_unlock, METH_VARARGS,
-   "unlocks the door in the specified direction." },
-  {"send", (PyCFunction)PyRoom_send, METH_VARARGS,
-   "send a message to everyone in the room."},
-  {NULL}  /* Sentinel */
-};
-
-
-//*****************************************************************************
-// character attributes - mostly get and set
-//*****************************************************************************
-static PyObject *
-PyRoom_getvnum(PyRoom *self, void *closure) {
-  ROOM_DATA *room = worldGetRoom(gameworld, self->vnum);
-  if(room != NULL) return Py_BuildValue("i", roomGetVnum(room));
-  else             return NULL;
-}
-
-static PyObject *
-PyRoom_getcharacters(PyRoom *self, PyObject *args) {
-  ROOM_DATA *room = worldGetRoom(gameworld, self->vnum);
-  if(room == NULL)
-    return NULL;
-  else {
-    LIST_ITERATOR *char_i = newListIterator(roomGetCharacters(room));
-    PyObject *list = PyList_New(0);
-    CHAR_DATA *ch;
-
-    // for each char in the room list, add him to a Python list
-    ITERATE_LIST(ch, char_i)
-      PyList_Append(list, newPyChar(ch));
-    deleteListIterator(char_i);
-    return Py_BuildValue("O", list);
-  }
-}
-
-static PyObject *
-PyRoom_getcontents(PyRoom *self, PyObject *args) {
-  ROOM_DATA *room = worldGetRoom(gameworld, self->vnum);
-  if(room == NULL)
-    return NULL;
-  else {
-    LIST_ITERATOR *obj_i = newListIterator(roomGetContents(room));
-    PyObject *list = PyList_New(0);
-    OBJ_DATA *obj;
-
-    // for each obj in the room list, add him to a Python list
-    ITERATE_LIST(obj, obj_i)
-      PyList_Append(list, newPyObj(obj));
-    deleteListIterator(obj_i);
-    return Py_BuildValue("O", list);
-  }
-}
-
-
-static PyGetSetDef PyRoom_getseters[] = {
-  {"vnum", (getter)PyRoom_getvnum, (setter)NULL,
-   "The room's vnum", NULL},
-  {"chars", (getter)PyRoom_getcharacters, (setter)NULL,
-   "The characters in the room", NULL},
-  {"objs", (getter)PyRoom_getcontents, (setter)NULL,
-   "The objects in the room", NULL},
-  {"contents", (getter)PyRoom_getcontents, (setter)NULL,
-   "The objects in the room", NULL},
-  {NULL}  /* Sentinel */
-};
-
-
 
 //*****************************************************************************
-// comparators, getattr, setattr, and all that other class stuff
+// structures to define our methods and classes
 //*****************************************************************************
-
-//
-// compare one character to another
-//
-static int
-PyRoom_compare(PyRoom *room1, PyRoom *room2) {
-  if(room1->vnum == room2->vnum)
-    return 0;
-  else if(room1->vnum < room2->vnum)
-    return -1;
-  else
-    return 1;
-}
-
-static PyTypeObject PyRoom_Type = {
+PyTypeObject PyRoom_Type = {
     PyObject_HEAD_INIT(NULL)
     0,                         /*ob_size*/
     "room.Room",               /*tp_name*/
@@ -498,48 +461,112 @@
     0,		               /* tp_weaklistoffset */
     0,		               /* tp_iter */
     0,		               /* tp_iternext */
-    PyRoom_methods,            /* tp_methods */
+    0,                         /* tp_methods */
     0,                         /* tp_members */
-    PyRoom_getseters,          /* tp_getset */
+    0,                         /* tp_getset */ 
     0,                         /* tp_base */
     0,                         /* tp_dict */
     0,                         /* tp_descr_get */
     0,                         /* tp_descr_set */
     0,                         /* tp_dictoffset */
-    (initproc)PyRoom_init,    /* tp_init */
+    (initproc)PyRoom_init,     /* tp_init */
     0,                         /* tp_alloc */
-    PyRoom_new,               /* tp_new */
+    PyRoom_new,                /* tp_new */
+};
+
+PyMethodDef room_module_methods[] = {
+  {NULL, NULL, 0, NULL}  /* Sentinel */
 };
 
 
 
 //*****************************************************************************
-// the room module
+// implementation of pyroom.h
 //*****************************************************************************
-static PyMethodDef room_module_methods[] = {
-  {NULL, NULL, 0, NULL}  /* Sentinel */
-};
+void PyRoom_addGetSetter(const char *name, void *g, void *s, const char *doc) {
+  // make sure our list of get/setters is created
+  if(pyroom_getsetters == NULL) pyroom_getsetters = newList();
+
+  // make the GetSetter def
+  PyGetSetDef *def = calloc(1, sizeof(PyGetSetDef));
+  def->name        = strdup(name);
+  def->get         = (getter)g;
+  def->set         = (setter)s;
+  def->doc         = (doc ? strdup(doc) : NULL);
+  def->closure     = NULL;
+  listPut(pyroom_getsetters, def);
+}
 
+void PyRoom_addMethod(const char *name, void *f, int flags, const char *doc) {
+  // make sure our list of methods is created
+  if(pyroom_methods == NULL) pyroom_methods = newList();
 
+  // make the Method def
+  PyMethodDef *def = calloc(1, sizeof(PyMethodDef));
+  def->ml_name     = strdup(name);
+  def->ml_meth     = (PyCFunction)f;
+  def->ml_flags    = flags;
+  def->ml_doc      = (doc ? strdup(doc) : NULL);
+  listPut(pyroom_methods, def);
+}
+
+
+// initialize rooms for use. This must be called AFTER 
 PyMODINIT_FUNC
 init_PyRoom(void) {
-    PyObject* m;
+    PyObject* module = NULL;
+
+    // add all of the basic getsetters
+    PyRoom_addGetSetter("vnum",  PyRoom_getvnum,   NULL, "The room's vnum");
+    PyRoom_addGetSetter("chars", PyRoom_getchars,  NULL, "chars in the room");
+    PyRoom_addGetSetter("objs",  PyRoom_getobjs,   NULL, "objects in the room");
+    PyRoom_addGetSetter("contents",PyRoom_getobjs, NULL, "objects in the room");
+
+    // add all of the basic methods
+    PyRoom_addMethod("attach", PyRoom_attach, METH_VARARGS,
+		     "attach a new script to the room.");
+    PyRoom_addMethod("detach", PyRoom_detach, METH_VARARGS,
+		     "detach a script from the room, by vnum.");
+    PyRoom_addMethod("close", PyRoom_close, METH_VARARGS,
+		     "close a door in the specified direction.");
+    PyRoom_addMethod("open", PyRoom_open, METH_VARARGS,
+		     "open a door in the specified direction. Also unlocks.");
+    PyRoom_addMethod("lock", PyRoom_lock, METH_VARARGS,
+		     "lock a door in the specified direction. Also closes.");
+    PyRoom_addMethod("unlock", PyRoom_unlock, METH_VARARGS,
+		     "unlocks a door in the specified direction.");
+    PyRoom_addMethod("send", PyRoom_send, METH_VARARGS,
+		     "send a message to everyone in the room.");
+
+    // add in all the getsetters and methods
+    makePyType(&PyRoom_Type, pyroom_getsetters, pyroom_methods);
+    deleteListWith(pyroom_getsetters, free); pyroom_getsetters = NULL;
+    deleteListWith(pyroom_methods,    free); pyroom_methods    = NULL;
 
+    // make sure the room class is ready to be made
     if (PyType_Ready(&PyRoom_Type) < 0)
         return;
 
-    m = Py_InitModule3("room", room_module_methods,
-                       "The room module, for all MUD room-related stuff.");
+    // initialize the module
+    module = Py_InitModule3("room", room_module_methods,
+			    "The room module, for all MUD room-related stuff.");
 
-    if (m == NULL)
+    // make sure the module parsed OK
+    if (module == NULL)
       return;
 
+    // add the Room class to the room module
+    PyModule_AddObject(module, "Room", (PyObject *)&PyRoom_Type);
     Py_INCREF(&PyRoom_Type);
-    PyModule_AddObject(m, "Room", (PyObject *)&PyRoom_Type);
 }
 
+
 int PyRoom_AsVnum(PyObject *room) {
   return ((PyRoom *)room)->vnum;
+}
+
+ROOM_DATA *PyRoom_AsRoom(PyObject *room) {
+  return worldGetRoom(gameworld, PyRoom_AsVnum(room));
 }
 
 int PyRoom_Check(PyObject *value) {
diff -ruN ../nakedmudv2.2/src/scripts/pyroom.d src/scripts/pyroom.d
--- ../nakedmudv2.2/src/scripts/pyroom.d	Thu May 12 17:08:51 2005
+++ src/scripts/pyroom.d	Fri May 27 01:33:34 2005
@@ -0,0 +1,4 @@
+scripts/pyroom.d scripts/pyroom.o: scripts/pyroom.c mud.h wrapsock.h property_table.h list.h map.h \
+  hashtable.h set.h buffer.h bitvector.h world.h room.h exit.h \
+  character.h handler.h utils.h scripts/pyplugs.h scripts/script_set.h \
+  scripts/script.h scripts/pychar.h scripts/pyobj.h scripts/pyroom.h
diff -ruN ../nakedmudv2.2/src/scripts/pyroom.h src/scripts/pyroom.h
--- ../nakedmudv2.2/src/scripts/pyroom.h	Thu May 12 17:08:51 2005
+++ src/scripts/pyroom.h	Fri May 27 01:30:57 2005
@@ -5,18 +5,40 @@
 // pyroom.h
 //
 // A python extention to allow python scripts to treat MUD rooms as an
-// object within the script.
+// object within the script. If you wish to give python access to more features
+// of a room, it should NOT be done by editing pyroom.c! Use PyRoom_addGetSetter
+// and PyRoom_addMethod in a new module implementing the feature you want to
+// give Python access to.
 //
 //*****************************************************************************
 
-/* initialize characters for use */
-PyMODINIT_FUNC
-init_PyRoom(void);
+// initialize rooms for use. This must be called AFTER all other modules
+// have added in new get/setters and methods to pyroom
+PyMODINIT_FUNC init_PyRoom(void);
+PyObject      *newPyRoom(ROOM_DATA *room);
 
-int PyRoom_AsVnum(PyObject *room);
-int PyRoom_Check(PyObject *value);
+ROOM_DATA *PyRoom_AsRoom(PyObject *room);
+int        PyRoom_AsVnum(PyObject *room);
 
-PyObject *
-newPyRoom(ROOM_DATA *room);
+//
+// checks to see if the PyObject is a PyRoom
+int        PyRoom_Check (PyObject *value);
+
+//
+// getters allow Python to access pieces of the Room module. Setters allow
+// Python to change pieces of the room module. Getters are called when Python
+// tries to get the value of some variable on the object, and setters are called
+// when Python tries to set the value of some variable on the object. Get and
+// Set do not both need to be supplied. Examples of how to add new getters and
+// setters is presented in pyroom.c
+void PyRoom_addGetSetter(const char *name, void *g, void *s, const char *doc);
+
+//
+// Adds a new method function (i.e. void *f) to the Room class. Name is the name
+// of the function, f is the PyCFunction implementing the new method, flags is
+// the type of method beings used (almost always METH_VARARGS), and dog is an
+// (optional) description of what the method does. For examples on how to add
+// new methods, see pyroom.c
+void PyRoom_addMethod(const char *name, void *f, int flags, const char *doc);
 
 #endif //__PYROOM_H
